function [J,w]=compute_JW(a,b,Y,Yc,Yz,Type,L_Type)
% 
% LICENSE CONDITIONS
% ==================================
% 
% Copyright   2011   The Regents of the University of California
% All Rights Reserved
% 
% Permission to use, copy, modify and distribute any part of this 
% code for Boosting Algorithms for Simultaneous Feature Extraction and 
% Selection for educational, research 
% and non-profit purposes, without fee, and without a written 
% agreement is hereby granted, provided that the above copyright 
% notice, this paragraph and the following three paragraphs appear 
% in all copies.
% 
% Those desiring to incorporate this code for TaylorBoost, SOPBoost and 
% POSBoost into commercial products or use for commercial purposes 
% should contact the Technology Transfer & Intellectual Property 
% Services, University of California, San Diego, 9500 Gilman Drive, 
% Mail Code 0910, La Jolla, CA 92093-0910, Ph: (858) 534-5815, 
% FAX: (858) 534-7345, E-MAIL:invent@ucsd.edu.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE 
% TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, 
% OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, 
% ARISING OUT OF THE USE OF THIS CODE FOR TAYLOR, SOP, POS - BOOST
% EVEN IF THE UNIVERSITY OF CALIFORNIA 
% HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% 
% THE CODE FOR TAYLOR, SOP, POS BOOST PROVIDED 
% HEREIN IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF 
% CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
% SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.  
% THE UNIVERSITY OF CALIFORNIA MAKES NO REPRESENTATIONS 
% AND EXTENDS NO WARRANTIES OF ANY KIND, EITHER IMPLIED 
% OR EXPRESS, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
% WARRANTIES OF MERCHANTABILITY OR FITNESS FOR 
% A PARTICULAR PURPOSE, OR THAT THE USE OF THE 
% CODE FORTAYLOR, SOP, POS BOOST WILL NOT 
% INFRINGE ANY PATENT, TRADEMARK OR OTHER RIGHTS.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if strcmp(L_Type,'Exp')==1
    J=b.*Y.*Yc.*Yz.*exp(-Yz.*Y.*a);
end

if strcmp(L_Type,'Log')==1
    J=2*b.*Y.*Yz.*Yc.*exp(-2*a.*Y.*Yz)./(1+exp(-2*a.*Y.*Yz));
end

if strcmp(L_Type,'Lap')==1
    V=Y.*Yz.*a;
    J=b.*Yc.*Y.*Yz.*(1-sign(V).*(1-exp(-abs(V))));
end

if strcmp(L_Type,'CBL')==1
    J=b.*Yc.*Yz.*(Y- (Yz.*a)./(sqrt(4+(Yz.*a).^2)));
end



if Type=='G'
    w=ones(size(J));
else
    
    if strcmp(L_Type,'Exp')==1
        w=((Yz.*b).^2).*Yc.*exp(-Yz.*Y.*a);
    end
    
    if strcmp(L_Type,'Log')==1
        w=4*(Yz.^2).*(b.^2).*Yc.*exp(-2*a.*Y.*Yz)./((1+exp(-2*a.*Y.*Yz)).^2);
    end
    
    if strcmp(L_Type,'Lap')==1
        V=Y.*Yz.*a;
        w=Yc.*((b.*Yz).^2).*exp(-abs(V));
    end
    
    if strcmp(L_Type,'CBL')==1
        w=(Yc.*4.*Yz.*Yz.*b.*b)./((4+(Yz.*a).^2).^(3/2));
    end
    
    J=J./w;
end

  

    
    
    
    