function errl=main_SOP(XF,Y,XFv,Yv,SS,step,C,Z,Tf,num,f,Type,L_Type)
% 
% LICENSE CONDITIONS
% ==================================
% 
% Copyright   2011   The Regents of the University of California
% All Rights Reserved
% 
% Permission to use, copy, modify and distribute any part of this 
% code for Boosting Algorithms for Simultaneous Feature Extraction and 
% Selection for educational, research 
% and non-profit purposes, without fee, and without a written 
% agreement is hereby granted, provided that the above copyright 
% notice, this paragraph and the following three paragraphs appear 
% in all copies.
% 
% Those desiring to incorporate this code for TaylorBoost, SOPBoost and 
% POSBoost into commercial products or use for commercial purposes 
% should contact the Technology Transfer & Intellectual Property 
% Services, University of California, San Diego, 9500 Gilman Drive, 
% Mail Code 0910, La Jolla, CA 92093-0910, Ph: (858) 534-5815, 
% FAX: (858) 534-7345, E-MAIL:invent@ucsd.edu.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE 
% TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, 
% OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, 
% ARISING OUT OF THE USE OF THIS CODE FOR TAYLOR, SOP, POS - BOOST
% EVEN IF THE UNIVERSITY OF CALIFORNIA 
% HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% 
% THE CODE FOR TAYLOR, SOP, POS BOOST PROVIDED 
% HEREIN IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF 
% CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
% SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.  
% THE UNIVERSITY OF CALIFORNIA MAKES NO REPRESENTATIONS 
% AND EXTENDS NO WARRANTIES OF ANY KIND, EITHER IMPLIED 
% OR EXPRESS, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
% WARRANTIES OF MERCHANTABILITY OR FITNESS FOR 
% A PARTICULAR PURPOSE, OR THAT THE USE OF THE 
% CODE FORTAYLOR, SOP, POS BOOST WILL NOT 
% INFRINGE ANY PATENT, TRADEMARK OR OTHER RIGHTS.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
warning off

%============================================Initialization================
Yc=(1-C)*(Y==1)+C*(Y==-1);
Yz=(1-Z)*(Y==1)+Z*(Y==-1);

Ycv=(1-C)*(Yv==1)+C*(Yv==-1);
Yzv=(1-Z)*(Yv==1)+Z*(Yv==-1);

Yc=2*Yc;    Ycv=2*Ycv;  
Yz=2*Yz;    Yzv=2*Yzv;

outf=[ num2str(num) '_' SS '_' Type '_' L_Type '_AmBoost_SOP_C' num2str(100*C) '_Z' num2str(100*Z)];
disp(outf)

loc=[pwd '/' ];

len=[];
temp.num=1;temp.a=1;temp.b=1;temp.itr=1;
F=temp;
m=0;


for i=1:Tf
    PP=evaluate_SOP(F,XF,f,len);
    if size(PP,1)==1
        FF=PP;
    else
        FF=sum(PP);
    end
    
    %%%% Updating current terms%%%%%%%%%%%%%%%%%   
    for j=1:m
        a=FF-PP(j,:);
        b=PP(j,:);
        [J,w]=compute_JW(a,b,Y,Yc,Yz,Type,L_Type);
        [Up(j),fx]=findbestmatlab(J,w,XF,f,step);
        [alpha,rhat(j)]=best_step(a,b,fx,Yc,Yz,Y,L_Type);
        Up(j).a=Up(j).a*alpha;
        Up(j).b=Up(j).b*alpha;
        Up(j).itr=i;
    end
    
   %%%%%%%%%%%%%%%Adding a new term%%%%%%%%%%%%%%%%%%55
    a=FF;
    b=ones(size(a));
    j=m+1;
    [J,w]=compute_JW(a,b,Y,Yc,Yz,Type,L_Type);
    [Up(j),fx]=findbestmatlab(J,w,XF,f,step);
    [alpha,rhat(j)]=best_step(a,b,fx,Yc,Yz,Y,L_Type);
    Up(j).a=Up(j).a*alpha;
    Up(j).b=Up(j).b*alpha;
    Up(j).itr=i;
    
    %%%%%%%%%%%%%%%%%% Selecting the Best Update%%%%%%%%%%%%%%%%%%%
    [p,q]=min(rhat);
   
    if q==m+1
        m=m+1;
        len(q)=1;
        F(m,1)=Up(q);
    else
        len(q)=len(q)+1;
        F(q,len(q))=Up(q);
    end
   
    %%%%%%%%%%%%%%%%%%%Display Progress%%%%%%%%%%%%%%%%    
    PP=evaluate_SOP(F,XF,f,len);
    PPv=evaluate_SOP(F,XFv,f,len);
    if size(PP,1)==1
        H=PP;
        Hv=PPv;
    else
        H=sum(PP);
        Hv=sum(PPv);
    end
        
    Lerror(i)=Risk_comp(H,Yc,Yz,Y,L_Type);
    Lerrorv(i)=Risk_comp(Hv,Ycv,Yzv,Yv,L_Type);
    [resul(:,i),err(i)]=testermulti(H,Y);
    [resulv(:,i),errv(i)]=testermulti(Hv,Yv);
    
    disp(['      Det      ' 'false      ' 'Loss      ' 'Error      ']);
    disp([resul(1,i),resul(2,i) Lerror(i)/1000 err(i)  ]);
    disp([resulv(1,i),resulv(2,i) 0  errv(i) ]);
    Disp_F(F,len,'x','+');
    outfile=sprintf('%s%s%d',outf,'_It_',i);
    disp(outfile);
    disp('==============================================')
    save([loc '/' outf],'F','Lerror','Lerrorv','resul','resulv','len','err','errv')
    clear Up rhat Up rhat PP PPv
end
errl=errv(end);
    
    
    
